<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>2018.02.05 строки, регулярные выражения</title>
</head>
<body>

<script>
    'use strict';


    /*
     1. Написать функцию isPalindrom(str), которая принимает строку и возвращает
     true если строка является палиндромом и false - если нет
     Например: строка madam - палиндром, а mama - нет
     */

    function isPalindrom(str) {
        var txt = str;

        for (var i = 0; i < txt.length / 2; i++) {

            if (txt.charAt(i) != txt.charAt((txt.length - i) - 1)) {
                str = false;
                break;
            }
            else {
                str = true;
            }
        }
        return str;
    }

    var result = isPalindrom("ара");
    console.log(result);


    /*
     2. Напишите функцию ucFirst(str), которая возвращает строку str с заглавным
     первым символом каждого слова, например:

     ucFirst("вася") == "Вася";
     ucFirst("") == ""; // нет ошибок при пустой строке
     P.S. В JavaScript нет встроенного метода для этого. Создайте функцию, используя toUpperCase() и charAt().
     */

    function ucFirst(str) {

        var s = str.split(" ");
        var str1 = "";

        for (var i = 0; i < s.length; i++) {

            for (var j = 0; j < s[i].length; j++) {

                if (j == 0) str1 += s[i].charAt(j).toUpperCase();

                else {
                    str1 += s[i].charAt(j);
                }

            }

            if (i < s.length - 1) str1 += " ";
        }

        str = str1;

        return str;
    }

    ucFirst("hello  false");


    /*
     3. Напишите функцию checkSpam(str), которая возвращает true, если строка
     str содержит „viagra“ или „XXX“, а иначе false.
     */

    function checkSpam(str) {

        var checkVal = str;

        var arr = ["viagra", "xxx"];
        var counter = 0;

        for (var i = 0; i < arr.length; i++) {

            checkVal = checkVal.toLowerCase();

            if (str = checkVal.indexOf(arr[i]) > -1) counter++;
            console.log(str);
        }

        str = counter > 0;

        return str;
    }

    checkSpam("innocent rabbit");


    /*
     4. Есть стоимость в виде строки: "$120". То есть, первым идёт знак валюты, а затем – число.
     Создайте функцию extractCurrencyValue(str), которая будет из такой
     строки выделять число-значение, в данном случае 120.
     */
    function extractCurrencyValue(str) {
        str = parseInt(str.substring(1));
        return str;
    }

    extractCurrencyValue('$120');


    /*
     5. Напишите JavaScript функцию которая возвращает переданную строку в алфавитном порядке.
     Пример строки : 'webmaster'
     Пример результата: 'abeemrstw'
     */
    function toAlphaBet(str) {

        var x = str.split("");

        x = x.sort();

        x = x.join("");

        str = x;

        return str;
    }
    console.log(toAlphaBet('webmaster'));

</script>

</body>
</html>